﻿namespace HeuristicLab.BenchmarkSuite.Problems {
  public class ForLoopIndex : BenchmarkSuiteDataDescriptor {
    private const string name = "For Loop Index - Hard";
    private const string fileName = "ForLoopIndex.csv";
    private const string description = "Given 3 integer inputs start,end, and step, print the integers in the sequence n|0 = start, n|i = n|i−1 + step for each n|i < end, each on their own line.";

    protected override string FileName { get { return fileName; } }

    public override string Name { get { return name; } }

    public override string Description { get { return description; } }

    protected override int InputArgumentCount { get { return 3; } }

    protected override int OutputArgumentCount { get { return 1; } }

    public override ProblemData CreateProblemData() {
      return new ProblemData(ProblemType.ForLoopIndex) {
        Name = Name,
        Description = Description,
        ProgramExecutionBudget = 30000000,
        Examples = CloneExamples(),
        BestResult = 0,
        WorstResult = 5000,
        InputArgumentTypes = new[] { ExampleArgumentType.Integer, ExampleArgumentType.Integer, ExampleArgumentType.Integer },
        OutputArgumentTypes = new[] { ExampleArgumentType.Print },
        TrainingCount = 100,
        TestCount = 1000,
        EnabledDataTypes = DataTypes.Exec | DataTypes.Integer | DataTypes.Boolean | DataTypes.String | DataTypes.Print,
        MaxSize = 300,
        EvalLimit = 600,
      };
    }

    protected override Example ParseExample(string[] input, string[] output) {
      return new Example {
        InputArgs = input,
        OutputArgs = output,
        InputInteger = ExampleArgumentConverter.ConvertIntegers(input),
        OutputPrint = output[0]
      };
    }
  }
}
